#!/usr/bin/ruby

class Array
    def bounds
	[max, min]
    end
end

def print_riv(riv,rank)
    return unless riv
    xmax,xmin = riv.map{|x,y| x}.bounds
    ymax,ymin = riv.map{|x,y| y}.bounds
    if xmax - xmin > 355
	riv1 = riv.map{|x,y| [x > 0 ? -180 : x, y] }
	riv2 = riv.map{|x,y| [x < 0 ?  180 : x, y] }
	xmax1,xmin1 = riv1.map{|x,y| x}.bounds
	ymax1,ymin1 = riv1.map{|x,y| y}.bounds
	xmax2,xmin2 = riv2.map{|x,y| x}.bounds
	ymax2,ymin2 = riv2.map{|x,y| y}.bounds
        outline1 = riv1.map{|x,y| "#{x},#{y}"}.join " "
	print "#{rank} #{xmin1} #{xmax1} #{ymin1} #{ymax1} #{outline1}\n"
# STDERR.print "#{rank} #{xmin1} #{xmax1} #{ymin1} #{ymax1} #{outline1}\n"
        outline2 = riv2.map{|x,y| "#{x},#{y}"}.join " "
	print "#{rank} #{xmin2} #{xmax2} #{ymin2} #{ymax2} #{outline2}\n"
# STDERR.print "#{rank} #{xmin2} #{xmax2} #{ymin2} #{ymax2} #{outline2}\n"
    else
        outline = riv.map{|x,y| "#{x},#{y}"}.join " "
        print "#{rank} #{xmin} #{xmax} #{ymin} #{ymax} #{outline}\n"
    end
end

lastriv = nil
rank = 1
STDIN.each {|line|
    if line =~ /segment \d+  rank (\d+)  points \d+/
	print_riv(lastriv,rank)
        rank = $1.to_i
        lastriv = []
    elsif line =~ /\t(-?\d+\.\d+) (-?\d+\.\d+)/
        x, y = $2.to_f, $1.to_f
        lastriv.push [x,y]
    else
        p line
        raise "River data parse error"
    end
}
print_riv(lastriv,rank)
